// -*- c++ -*-
// Generated by assa-genesis
//------------------------------------------------------------------------------
// $Id: Granule-main.h,v 1.21 2006/11/14 03:33:27 vlg Exp $
//------------------------------------------------------------------------------
//                            Granule-main.h
//------------------------------------------------------------------------------
//  Copyright (c) 2004 by Vladislav Grinchenko
//
//  This program is free software; you can redistribute it and/or 
//  modify it under the terms of the GNU General Public License   
//  as published by the Free Software Foundation; either version  
//  2 of the License, or (at your option) any later version.      
//------------------------------------------------------------------------------
//
// Date   : Wed Dec 31 23:18:34 2003
//
//------------------------------------------------------------------------------

#ifndef MAIN_H
#define MAIN_H

#include <assa/Assure.h>

using ASSA::APP;
using ASSA::TRACE;
using ASSA::ALL;

enum { GRAPP     = ASSA::APP,	// 0x00000002
	   GUITRACE  = ASSA::USR1,	// 0x00000004
	   DECK      = ASSA::USR2,	// 0x00000008
	   GEOM      = ASSA::USR3,	// 0x00000010
       KEYIN     = ASSA::RES5,  // 0x02000000
       CSVPARSER = ASSA::RES6   // 0x04000000
};

typedef enum {
    Start = 0,
    Dirty,						/// Lesson deck has been modified
    Clean,						/// No modifications has been done
    Finish						
} WMState;

typedef enum { 
	FRONT, 
	BACK,
	EXAMPLE
} SideSelection;

typedef enum { 
	LOAD_OK, 
	LOAD_FAILED 
} DeckLoadStatus;

typedef enum {
	INSTALL_DECK,				// Load a deck from a file
	ADD_TO_DECK					// Add cards to a deck from another deck file
} DeckAction;

typedef enum {
	NEW_DECK,					// Brand new deck (different from MODIFIED)
	INVALID_DECK,				// Tried and failed to load the deck
	MODIFIED_DECK,				// Deck has been modified with edit/add/delete
	CLEAN_DECK					// Deck doesn't need to be saved
} DeckEditStatus;

enum {
	CARD_BOX_SIZE = 5,
	MAX_CARDS     = 100000,		// Maximum cards in Deck/CardFile
};

typedef enum {
	SPACE_SEP,
	TAB_SEP,
	COLON_SEP,
	SEMICOLON_SEP,
	COMMA_SEP,
} CSVSeparator;

/** Indexes into text alignment combo control widgets.
 *  These differ from both Gtk::AlignmentEnum and Gtk::Justification.
 */
enum {
	TA_X_ALIGN_CENTER,
	TA_X_ALIGN_LEFT,
	TA_X_ALIGN_RIGHT
};

enum {
	TA_Y_ALIGN_CENTER,
	TA_Y_ALIGN_TOP,
	TA_Y_ALIGN_BOTTOM
};

enum {
	TA_JUSTIFY_CENTER,
	TA_JUSTIFY_LEFT,
	TA_JUSTIFY_RIGHT,
	TA_JUSTIFY_FILL
};


/*------------------------------------------------------------------------------
 * Some useful defines and define macros
 *------------------------------------------------------------------------------
 */
#define CARD_FILE_EXT  ".cdf"
#define DECK_FILE_EXT  ".dkf"
#define UNKNOWN_FNAME  "Unknown"       /* Name of 'New' CardFile */


#endif /* MAIN_H */

